#!/usr/bin/env python
# -*- coding: utf-8 -*-

# = = = EXECUTE: = = = 
# python3 30_scan_doi.py ../raw_sqlite/book.sqlite
# = = = = = = = = = = = = 


import sys
import json
import pprint
from datetime import datetime
import sqlite3
import re


INPUTA     = "www.json"
INPUTB     = "www.json"
if len(sys.argv)>1 and sys.argv[1]!=None: INPUTA = sys.argv[1]
if len(sys.argv)>2 and sys.argv[2]!=None: INPUTB = sys.argv[2]



def get_records( dbname , elems=["doi","id"] ):
	conn = sqlite3.connect( dbname )
	conn.row_factory = sqlite3.Row# Magic line!
	conn.isolation_level = None
	c = conn.cursor()
	c.execute(  'SELECT '+",".join(elems)+' FROM publication where '+elems[0]+'!="" limit 100 ' )
	results = c.fetchall()
	conn.close()
	return results


def get_records_fromList( dbname , elems=["doi","id"] , List=[] ):
	results = []

	N_ = len(List)
	K = []
	k_size = 499
	divisor = round( N_ / float(k_size) )+1
	for i in range(divisor):
		from_ = k_size * i 
		if from_>=N_: break
		to_   = (k_size * (i+1)) -1 
		K.append( [ from_ , to_ ] )
	K[-1][-1] = (N_-1)
	
	queries = []
	for k in K:
		print(k[0],"-",k[1],":\t", len( List[ k[0]:k[1] ] ) )
		st = "' OR "+elems[0]+"='"
		R = st.join(  List[ k[0]:k[1] ]   ) 
		R = elems[0]+"='"+R+"'"
		# print(R)
		conn = sqlite3.connect( dbname )
		conn.row_factory = sqlite3.Row# Magic line!
		conn.isolation_level = None
		c = conn.cursor()
		print(R)
		# print('SELECT '+",".join(elems)+' FROM publication where '+R)
		c.execute(  'SELECT '+",".join(elems)+" FROM publication where "+R )
		results.append( c.fetchall() )
		conn.close()

	return results

Pa = {}
for p in get_records( INPUTA , elems=["doi","title"] ):
	Pa[p["doi"]] = p["title"]
# for doi in Pa:
# 	print( doi )

print("")
print("")

results = get_records_fromList( dbname=INPUTB ,elems=["name"], List=list(Pa.values()) )

TOTAL = 0
for i in results:
	for r in dict(i):
		TOTAL+=1
print("")
print("")
print("N:",len(list(Pa.keys())))
print("MATCHED:",TOTAL)
print("")
print("")


