# import gzip
from lxml import etree
import pprint
import re
import sys
# from io import StringIO, BytesIO

# # open and read gzipped xml file
# infile = gzip.open( "citeseerx_sample.xml" )
# content = infile.read()

# tree = etree.parse(StringIO( content ))
# msg = etree.tostring( tree.getroot() )

INPUT = ""
if len(sys.argv)>1 and sys.argv[1]!=None: INPUT=sys.argv[1]


exclude_keywordsmsg = re.compile( '^key words[^\w]*' )

IN = {
	'creator': True,
	'date': True,
	'datestamp': True,
	'description': True,
	'format': True,
	'identifier': True,
	'language': True,
	'publisher': True,
	'source': True,
	'subject': True,
	'title': True,
}

OUT = {
	'doi': "doi",
	'oai_id': "oai_id",
	'url': "url",
	'title': "name",
	'date': "date",
	'description': "abstract",
	'creator': "authors",
	'subject': "keywords",
	'publisher': "publisher",
	'format': "format",
	'source': "fulltext",
	'language': "lang",
}

DATA = {}
I = 0

K = {}
def parse_resource( record ):
	info = {}
	for i in record:
		if i[0] in IN:
			if i[0] not in info:
				info[ i[0] ] = []
			info[ i[0] ].append( i[1] )


	# - - - [ DATE ] - - - #
	if "date" in info: info["date"] = [ info["date"][-1] ]
	else: info["date"] = [ info["datestamp"][-1] ]
	del info["datestamp"]
	# - - - [ / DATE ] - - - #


	# - - - [ ABSTRACT ] - - - #
	if "description" in info:
		txt = info["description"][0]
		txt = re.sub( r'^abstract[^\w]*' , '', txt , flags=re.IGNORECASE)
		txt = re.sub( r'^abstract[^\w]*' , '', txt , flags=re.IGNORECASE)
		info["description"] = [ txt ]
	# - - - [ / ABSTRACT ] - - - #


	# - - - [ IDs ] - - - #
	if "identifier" in info:
		info["oai_id"] = [ info["identifier"][0] ]
		info["url"] = [ info["identifier"][1] ]
		info["doi"] = [ info["url"][0].split("doi=")[-1] ]
		del info["identifier"]
	# - - - [ / IDs ] - - - #


	for k in sorted( info.keys() ):
		if isinstance( info[k] , list ) :
			array = info[k]
			if k=="subject":
				array = [x.lower() for x in array]
				info[k] = [ "|".join( array )  ]
				if array[0].startswith("key words"): 
					array[0] = exclude_keywordsmsg.sub('', array[0])
				if array[0]=="" or array[0]==" ":
					array = array[1:]
				if len(array)>1:
					info[k+"02"] = "|".join( array )
					info[k] = [ info[k+"02"] ]
				else: 
					del info[k]

				try: del info[k+"02"]
				except: pass
			if k=="creator":
				info[k] = [ "|".join( info[k] ) ]

		try: info[k] = info[k][0]
		except: pass



	standard_info = {}
	for k in sorted( info.keys() ):
		# print( "\t", k , ":", info[k] )
		key = OUT[k]
		value = info[k]
		standard_info[ key ] = value
		if k not in K:
			K[k] = 0
		K[k] += 1

	global DATA
	global I
	DATA[ I ] = standard_info
	I += 1
	# print("")
	# print("")


xmlFile = INPUT
context = etree.iterparse( xmlFile )

record = []
for action, elem in context:
	tag = elem.tag.replace( "{http://purl.org/dc/elements/1.1/}","" )
	tag = tag.replace( "{http://www.openarchives.org/OAI/2.0/oai_dc/}","" )
	
	if tag == "record":
		parse_resource( record )
		record = []
	else:
		if elem.text != None:
			record.append( [ tag , elem.text ] )
		


pprint.pprint( K )


test_name = "citeseerx"
sqldbname = test_name+".sqlite"

import sqlite3
conn = sqlite3.connect( sqldbname )
conn.row_factory = sqlite3.Row# Magic line!
conn.isolation_level = None
c = conn.cursor()

sql_commands = [
	"DROP TABLE IF EXISTS publication;",
	"CREATE TABLE publication( doi VARCHAR(250) , oai_id VARCHAR(250) , url TEXT, name TEXT , date VARCHAR(100) , abstract TEXT , authors TEXT , keywords TEXT , publisher TEXT ,format VARCHAR(100) , fulltext TEXT , lang VARCHAR(10) )",
]

for command in sql_commands:
	c.execute(  command )
	conn.commit()

from SQL import SQL
execc = SQL()
execc.InsertInto_modular( connection=conn , cursor=c , tablename="publication" , data= DATA )
conn.close()