#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
import json
import pprint
from datetime import datetime

AUTHOR = {}
OK = {
	"id" : True,
	"author" : True,
	"cite" : True,
	"url" : True,
	"crossref" : True,
	"note" : True,
}
AUTHOR_s2i = {}


INPUT     = "www.json"
OUTPUT    = "folder"
if len(sys.argv)>1 and sys.argv[1]!=None: INPUT = sys.argv[1]
if len(sys.argv)>2 and sys.argv[2]!=None: OUTPUT = sys.argv[2]


print("reading...")
f = open( INPUT , "r" )
P = json.load( f )
f.close()
print( " reading OK ")


c = 0
for i in P:
	c += 1
	# if c==5000:
	# 	break
	p = P[i]
	info = {}
	for k in sorted(p.keys()):
		if k in OK:
			info[k] = "||".join( p[k] )
			if k=="author":
				for a in p[k]:
					if a not in AUTHOR_s2i:
						AUTHOR_s2i[a] = []
					AUTHOR_s2i[a].append( p["id"][0] )

	AUTHOR[ info["id"] ] = info


for a in AUTHOR_s2i:
	AUTHOR_s2i[a] = {
		"id" : "||".join( AUTHOR_s2i[a] ) , 
		"author" : a
	}


import sqlite3
from DBbulk import SQL
execc = SQL()
test_name = "author"
sqldbname = test_name+".sqlite"
conn = sqlite3.connect( OUTPUT+"/"+sqldbname )
conn.row_factory = sqlite3.Row# Magic line!
conn.isolation_level = None
c = conn.cursor()
sql_commands = [
	"DROP TABLE IF EXISTS author;",
	"DROP TABLE IF EXISTS author_s2i;",
	"CREATE TABLE author( id VARCHAR(200) PRIMARY KEY , author TEXT , cite TEXT , url TEXT , crossref TEXT , note TEXT )",
	"CREATE TABLE author_s2i( author VARCHAR(250) , id VARCHAR(250) )",
	"CREATE INDEX author_idx ON author_s2i ( author )",
	"CREATE INDEX id_idx ON author_s2i ( id )",

]
for command in sql_commands:
	c.execute(  command )
	conn.commit()

execc.InsertInto_modular( connection=conn , cursor=c , tablename="author" , data=AUTHOR )
execc.InsertInto_modular( connection=conn , cursor=c , tablename="author_s2i" , data=AUTHOR_s2i )
conn.close()
print
print "END"