#!/usr/bin/env python
# -*- coding: utf-8 -*-

# = = = EXECUTE: = = = 
# python2 20_scan_pubs.py ../raw_json/article.json ../raw_sqlite
# = = = = = = = = = = = = 


import sys
import json
import pprint
from datetime import datetime

OK = {
	"id" : "VARCHAR(255)",
	"author" : "TEXT",
	"booktitle" : "TEXT",
	"url" : "TEXT",
	"crossref" : "VARCHAR(255)",
	"ee" : "TEXT",
	"isbn" : "TEXT",
	"journal" : "TEXT",
	"number" : "VARCHAR(100)",
	"pages" : "VARCHAR(255)",
	"pages_nb" : "INTEGER",
	"publisher" : "TEXT",
	"series" : "VARCHAR(255)",
	"title" : "TEXT",
	"type" : "VARCHAR(100)",
	"volume" : "VARCHAR(100)",
	"year" : "INTEGER",
}










AUTHOR = {}
local_authors = {}
AUTHOR_s2i = {}


INPUT     = "www.json"
OUTPUT    = "folder"
if len(sys.argv)>1 and sys.argv[1]!=None: INPUT = sys.argv[1]
if len(sys.argv)>2 and sys.argv[2]!=None: OUTPUT = sys.argv[2]


print("reading...")
f = open( INPUT , "r" )
P = json.load( f )
f.close()
print( " reading OK ")
print( "" )
print( "" )
print( "" )

D = {}

STATS = {}
c = 0
for i in P:
	c += 1
	# if c==1000:
	# 	break

	p = P[i]
	info = {}
	for k in sorted( p.keys() ):
		if k in OK:
			info[k] = "||".join( p[k] )
	D[info["id"]] = info
# # 	for k in sorted( p.keys() ):
# # 		if k not in STATS:
# # 			STATS[k] = {
# # 				"c": 0,
# # 				"avg_len":0
# # 			}
# # 		STATS[k]["c"] += 1
# # 		STATS[k]["avg_len"] += len(p[k])

# # N = STATS["id"]["c"]
# # for i in STATS:
# # 	STATS[i]["avg_len"] = STATS[i]["avg_len"]/float(STATS[i]["c"])
# # 	if STATS[i]["c"]/float(N) >= 0.4:
# # 		print( i ,"\t\t", STATS[i]  )



import sqlite3
conn = sqlite3.connect( "../raw_sqlite/author.sqlite" )
conn.row_factory = sqlite3.Row# Magic line!
conn.isolation_level = None
c = conn.cursor()
c.execute(  "SELECT author,id FROM author_s2i;" )
WWW = c.fetchall()
for a in WWW:
	if a["author"] not in AUTHOR:
		AUTHOR[a["author"]] = a["id"]
conn.close()



for i in D:
	p = D[i]
	if "author" in p:
		authors = p["author"].split("||")
		authors_IDs = []
		for a in authors:
			if a in AUTHOR:
				authors_IDs.append( AUTHOR[a] )
		D[i]["author"] = "||".join( authors_IDs )


sql_columns = []
for i in OK:
	sql_columns.append( i+" "+OK[i] )
sql_columns.append( "doi VARCHAR(255)" )
sql_columns = " , ".join( sql_columns )
create_table =  "CREATE TABLE publication( "+sql_columns+" )"

from DBbulk import SQL
execc = SQL()
test_name = INPUT.split("/")[-1]
sqldbname = test_name+".sqlite"
conn = sqlite3.connect( OUTPUT+"/"+sqldbname )
conn.row_factory = sqlite3.Row# Magic line!
conn.isolation_level = None
c = conn.cursor()
sql_commands = [
	"DROP TABLE IF EXISTS publication;",
	create_table ,

]
for command in sql_commands:
	c.execute(  command )
	conn.commit()

execc.InsertInto_modular( connection=conn , cursor=c , tablename="publication" , data=D )
conn.close()
print
print "END"