#!/usr/bin/env python
# -*- coding: utf-8 -*-

# = = = EXECUTE: = = = 
# python3 30_scan_doi.py ../raw_sqlite/book.sqlite
# = = = = = = = = = = = = 


import sys
import json
import pprint
from datetime import datetime


INPUT     = "www.json"
if len(sys.argv)>1 and sys.argv[1]!=None: INPUT = sys.argv[1]

import sqlite3
conn = sqlite3.connect( INPUT )
conn.row_factory = sqlite3.Row# Magic line!
conn.isolation_level = None
c = conn.cursor()
c.execute(  "SELECT id,url,ee FROM publication;" )
P = c.fetchall()

for p in P:
	info = { "id" : p["id"] }
	if p["url"]!=None and "doi" in p["url"]: 
		raw = p["url"].split("||")
		for r in raw:
			if "doi" in r:
				info["raw"] = r
				break
	else:
		if p["ee"] !=None and "doi" in p["ee"]: 
			raw = p["ee"].split("||")
			for r in raw:
				if "doi" in r:
					info["raw"] = r
					break
	if len(info.keys())>1:
		info["doi"] = info["raw"].replace("http://dx.doi.org/","")
		info["doi"] = info["doi"].replace("http://dl.acm.org/citation.cfm?doid=","")
		info["doi"] = info["doi"].replace("http://doi.acm.org/","")
		info["doi"] = info["doi"].replace("http://doi.ieeecomputersociety.org/","")
		# info["doi"] = info["doi"].replace("http://onlinelibrary.wiley.com/doi/","")
		info["doi"] = info["doi"].replace("http://www.worldscinet.com/doi/abs/","")
		info["doi"] = info["doi"].replace("http://eudl.eu/doi/","")
		info["doi"] = info["doi"].replace("http://citeseerx.ist.psu.edu/viewdoc/summary?doi=","") 
		info["doi"] = info["doi"].replace("http://www.tandfonline.com/doi/abs/","")
		info["doi"] = info["doi"].replace("http://www.mitpressjournals.org/doi/abs/","")

		sql_upd = "UPDATE publication SET doi = \""+info["doi"]+"\" WHERE id = \""+ info["id"] +"\";"
		if info["doi"][0]!="1":
			print( sql_upd )
		else:
			c.execute( sql_upd )

conn.commit()
conn.close()
