#!/usr/bin/env python
# -*- coding: utf-8 -*-

import pprint
import re
import json
from lxml import etree
xml_content = etree.iterparse(source="dblp_fix.xml", dtd_validation=True, load_dtd=True) # etree.parse("dblp.xml", parser)

def count_pages(pages):
    """
    source: https://github.com/billjh/dblp-iter-parser
    """
    cnt = 0
    reRange = r"([\w\d:]+)-([\w\d:]+)"
    for part in re.compile(r",").split(pages):
        subparts = re.compile(r"-").split(part)
        if len(subparts) > 2:
            continue
        else:
            try:
                reDigits = re.compile(r"[\d]+")
                subparts = [int(reDigits.findall(sub)[-1]) for sub in subparts]
            except IndexError:
                continue
            cnt += 1 if len(subparts) == 1 else subparts[1]-subparts[0]+1
    return "" if cnt == 0 else str(cnt)

def parsetheshitoutofthis( p ):
	info = {}

	for k in sorted(p.keys()):
		info[k] = p[k]
		if k=="pages":
			info["pages_nb"] = [ count_pages( p[k][0] )  ]
	return info


D = {}

OK = set(["article", "inproceedings", "proceedings", "book",
                "incollection", "phdthesis", "mastersthesis", "www"])



p = {}
c = 0
for _, elem in xml_content:
	
	if elem.tag in OK:
		if len(elem.items())!=0:
			for attr_name, attr_value in elem.items():
				if attr_name=="mdate":
					p["mdate"] = [ attr_value ]
				if attr_name=="key":
					p["id"] = [attr_value]
			p["type"] = [ elem.tag ]
			record = parsetheshitoutofthis( p )
			if p["type"][0] not in D:
				D[p["type"][0]] = {}
			if record["id"][0] not in D[p["type"][0]]:
				D[p["type"][0]][ record["id"][0] ] = record
			p = {}
			c =+ 1

	else:
		if elem.tag not in p:
			p[elem.tag] = []
		p[elem.tag].append( elem.text )

print("\nwriting jsons...")
for i in D:
	print(len(D[i].keys()) , ":",i)
	with open( "raw_json/"+i+".json", 'w') as outfile:
		json.dump( D[i] , outfile, ensure_ascii=False , indent=1 )
