#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sqlite3
import time


class Extract:

	def __init__( self , DEBUG ):
		self.stats = {
			"Pubs" : 0,
			"Pubs+Aid" : 0,
			"nodes" : 0,
			"edges" : 0,
			"times" : []
			# "cliques" : len(cliques),
		}
		self.DBLP = {
			"P_s2i": {},
			"P_i2s": {},
			"A_s2i": {},
			"A_i2s": {},
			"years": {}
		}
		self.DEBUG = DEBUG

	def get_time_s( self , start ):
		return "{0:.2f}".format((time.time() -  start))


	def calc_DBLP_OCCs ( self, dbfile , tablas=[ "articles", "conferences" , "books"] , t = ["1970","1980"] ):

		if self.DEBUG: print( time.strftime("%H:%M:%S") , "calc_DBLP_OCCs" )

		self.stats["times"].append( [ time.strftime("%H:%M:%S") , "calc_DBLP_OCCs" ] )

		start = time.time()
		
		connDBLP=sqlite3.connect( dbfile )
		connDBLP.row_factory = sqlite3.Row# Magic line!
		cursorDBLP=connDBLP.cursor()

		timerestr = ' where year>='+t[0]+' and year<='+t[1]

		N_aid = 0
		N_np = 0

		rawdata = []
		FreqD = {}

		A_ID = 0
		ID = 0
		for tablaDBLP in tablas:
			# query='SELECT idUrl,year FROM '+tablaDBLP + timerestr
			query='SELECT idUrl FROM '+tablaDBLP + timerestr
			# print(query)
			cursorDBLP.execute(query)
			rows = cursorDBLP.fetchall()

			recent_pubs = []
			for pub in rows:
				authorID={}
				idPub = pub['idUrl']
				# print( ID,"\t" ,idPub ,"\t", title )
				if idPub not in self.DBLP["P_s2i"]:
					self.DBLP["P_s2i"][idPub] = ID
					self.DBLP["P_i2s"][ID] = idPub
					recent_pubs.append( idPub )
					ID += 1

				# if pub["year"] not in self.DBLP["years"]:
				# 	self.DBLP["years"][ pub["year"] ] = {
				# 		"books" : 0,
				# 		"articles" : 0,
				# 		"conferences" : 0
				# 	}
				# self.DBLP["years"][ pub["year"] ][ tablaDBLP ] += 1

			conn1 = sqlite3.connect( dbfile )
			conn1.row_factory = sqlite3.Row# Magic line!
			cur1 = conn1.cursor()
			for idPub in recent_pubs:
				cur1.execute('SELECT authorID FROM urls_'+tablaDBLP+' WHERE idUrl="'+idPub+'"')
				authors = []
				for a in cur1.fetchall():
					author = -1
					if a["authorID"] not in self.DBLP["A_s2i"]:
						A_ID += 1
						self.DBLP["A_s2i"][ a["authorID"] ] = A_ID
						self.DBLP["A_i2s"][ A_ID ] = a["authorID"]
						author = A_ID
					else:
						author = self.DBLP["A_s2i"][ a["authorID"] ]
					authors.append( author )

					if author not in FreqD:
						FreqD[ author ] = 0
					FreqD[ author ] += 1

				rawdata.append( authors )
				# print( idPub , authors )

		self.stats["times"].append( [ self.get_time_s( start ) , "data-extr + elems-OCCs" ] )
		self.stats["Pubs"] = len( self.DBLP["P_i2s"].keys() )
		self.stats["Pubs+Aid"] = self.stats["Pubs"]

		return rawdata , FreqD

