#!/usr/bin/env python
# -*- coding: utf-8 -*-


# = = = [ EXECUTION EXAMPLE ] = = = ] #
#
#
#      nohup   python3 02_parse_isi.py ISIFILE  /output/jsons/folder  &
#
#
# = = = [ / EXECUTION EXAMPLE ] = = = ] #



import sys

D = {}


INPUT     = "MN3A97OV"
OUTPUT    = "folder"
if len(sys.argv)>1 and sys.argv[1]!=None: INPUT = sys.argv[1]
if len(sys.argv)>2 and sys.argv[2]!=None: OUTPUT = sys.argv[2]
rawfile = INPUT.split("/")[-1]

PY = -1
PT = -1
SO = -1
JI = -1
PD = -1
SC = -1
def parse_this( P ):

	global PY
	global PT
	global SO
	global JI
	global PD
	global SC

	data = {}

	for line in P:
		if line.startswith("CR") or line.startswith("R9") or line.startswith("/") or line.startswith("EC"):
			x = 1
		else:
			header  = line[0:2]
			content = line[3:]
			if content != "":
				if header not in data:
					data[header] = []
				data[header].append( content )


	if "AB" in data:
		data["AB"] = " ".join( data["AB"] )
	for d in data:
		if isinstance( data[d] , list ) and len(data[d])==1:
			data[d] = data[d][0]

	if "PY" not in data: data["PY"] = PY
	else: PY = data["PY"]

	if "PT" not in data:  data["PT"] = PT
	else: PT = data["PT"]

	if "PD" not in data: data["PD"] = PD
	else: PD = data["PD"]

	if "SO" not in data:  data["SO"] = SO
	else: SO = data["SO"]

	if "JI" not in data:  data["JI"] = JI
	else: JI = data["JI"]

	if "SC" not in data: data["SC"] = SC
	else: SC = data["SC"]

	return data


f = open( INPUT , "r" )
Lines = []

c = 0
P_delim = []

try:
	for i in f: 
		line = i.replace( "\n" , "" )
		if line.startswith("UT"):
			P_delim.append( c )

		if line.startswith( "-- " ):
			Lines[-1] = Lines[-1] + line.replace("-- ","")
		else:
			Lines.append( line )
			c += 1
	f.close()


	for i in range(len(P_delim)):
		try:
			x = P_delim[i+1]
		except:
			break

		a = P_delim[i]
		b = P_delim[i+1] - 1

		pub = parse_this ( Lines[a:b] )
		if pub["UT"] not in D:
			D[ pub["UT"] ] = pub


	import json
	with open( OUTPUT + "/" + rawfile+".json", 'w') as outfile:
		json.dump(D, outfile, ensure_ascii=False )

except:
	print( "ERRROR", rawfile )

