#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
import json
import pprint
from datetime import datetime



# Pubmed 1982 -> 2014 :   In average 93% of the publications have MeSH keywords assigned.
#     (2015 has no MeSH keywords)

# Example of Pubmed dates:
# 	# the most common:
# 		1982 Nov 15
# 		1982 Nov
# 		1982
# 	# not that common:
# 		1982 Apr 28-May 4
# 		1982 Dec 22-1983 Jan 4
# 		1982 Oct-1983 Jan
# 		1982 4th Quart
# 		1982 Jan l4
# 		1988 Aug G
# 		1989 Apr IL
# 		1989 Sep T
# 		1990 Nov C
# 		1987 May Y
# 		1985 Hilary Term
# 		1987 (date enacted)
# 		1987 EASTER
# 		1987 CHRISTMAS
# 		2011 September/October
# 		2010 October-December
# 		1982 May-Jun
# 		1982 Fall
# 		1985 Summer


class DateFormatter:

	def __init__(self):
		self.hola = "mundo"

	def format_date_DP( self , string ):

		date_dp = False

		raw_date = string.split("-")[0]

		tmp = raw_date.split( " " )
		seas_flag = tmp[-1].strip().lower()
		if seas_flag=="winter": tmp[-1] =  "Jan"
		if seas_flag=="spring": tmp[-1] =  "Apr"
		if seas_flag=="easter": tmp[-1] =  "Apr"
		if seas_flag=="summer": tmp[-1] =  "Jul"
		if seas_flag=="fall":   tmp[-1] =  "Oct"
		if seas_flag=="autumn": tmp[-1] =  "Oct"
		if seas_flag=="autust": tmp[-1] =  "Oct"
		if seas_flag=="christmas": tmp[-1] =  "Dec"

		raw_date = " ".join( tmp )

		try:
			date_dp = datetime.strptime( raw_date , "%Y %b").date()
		except:
			raw_date = raw_date.split("-")[0]
			try:
				date_dp = [ datetime.strptime( raw_date , "%Y").date() , True ]
			except:
				# print("\tRECC:", string ,"->  ", raw_date )
				date_dp = datetime.strptime('31000103', "%Y%m%d").date()
				pass

		return date_dp

	def format_date (self , p ):

		raw_dep = "None"
		raw_dp = "None"
		raw_crdt = "None"
		date_final = datetime.strptime('31000101', "%Y%m%d").date()
		date_dep = datetime.strptime('31000102', "%Y%m%d").date()
		date_dp = datetime.strptime('31000103', "%Y%m%d").date()
		date_crdt = datetime.strptime('31000104', "%Y%m%d").date()

		if "DEP" in p:
			raw_dep = p["DEP"][0]
			date_dep = datetime.strptime( raw_dep , "%Y%m%d").date()
			date_final = date_dep

		else:

			if "DP" in p:

				raw_dp = p["DP"][0]

				date_parts = len(raw_dp.split(" "))
				if date_parts>=4:
					raw_dp = raw_dp.split("-")[0]
					date_parts = len(raw_dp.split(" "))

				if date_parts==2:
					date_dp = format_date_DP( raw_dp )

				if date_parts==3:
					raw_date = raw_dp.split("-")[0]
					try:
						date_dp = datetime.strptime( raw_date , "%Y %b %d").date()
					except:
						date_dp = format_date_DP( raw_date )



			if "CRDT" in p:
				raw_crdt = p["CRDT"][0]
				date_crdt = datetime.strptime( raw_crdt , "%Y/%m/%d %H:%M").date()


			if isinstance( date_dp , list ):
				date_dp = date_dp[0]
				if abs( date_crdt.year - date_dp.year )==0:
					date_final = date_crdt
					# print( "\t",raw_dp ,"vs", raw_crdt )
				else:
					if abs( date_crdt.year - date_dp.year )>=2:
						date_final = date_dp
					else:
						date_final = date_crdt
			else:
				date_final = min( date_dp , date_crdt )


			# date_final = min( date_dp , date_crdt )


		return [ date_final , p["PMID"][0] ,"options:", raw_dep , raw_dp , raw_crdt ]



D = {}


INPUT     = "raw_json/Pubmed_2011[dp].txt.json"
OUTPUT    = "folder"
if len(sys.argv)>1 and sys.argv[1]!=None: INPUT = sys.argv[1]
if len(sys.argv)>2 and sys.argv[2]!=None: OUTPUT = sys.argv[2]


print("reading...")
f = open( INPUT , "r" )
P = json.load( f )
f.close()
print( " reading OK ")



process_ = DateFormatter()
c = 0
for i in P:
	c += 1
	# if c == 5000:
	# 	break
	p = P[i]
	date_fin = process_.format_date( p )
	p["date"] = date_fin[0]




