# import gzip
from lxml import etree
import pprint
import re
import sys
# from io import StringIO, BytesIO

# # open and read gzipped xml file
# infile = gzip.open( "citeseerx_sample.xml" )
# content = infile.read()

# tree = etree.parse(StringIO( content ))
# msg = etree.tostring( tree.getroot() )

INPUT = ""
if len(sys.argv)>1 and sys.argv[1]!=None: INPUT=sys.argv[1]


exclude_keywordsmsg = re.compile( '^key words[^\w]*' )


IN = {
	'id': True,
	'doi': True,
	'identifier': True,

	'acm-class': True,
	'msc-class': True,
	'setSpec': True,
	'categories': True,
	'journal-ref': True,

	'keyname': True,
	'forenames': True,
	'suffix': True,
	'affiliation': True,

	'title': True,
	'created': True,
	'updated': True,
	'abstract': True,
	'comments': True,
}

Author_Keys = {
	'keyname': True,
	'forenames': True,
	'suffix': True,
	'affiliation': True,
}

OUT = {
	'id': "id",
	'doi': "doi",
	'identifier': "oai_id",

	'acm-class': "acm_class",
	'msc-class': "msc_class",
	'setSpec': "domain",
	'categories': "subdomain",
	'journal-ref': "journal",

	'title': "name",
	'created': "date",
	'updated': "date_updated",
	'abstract': "abstract",
	'comments': "comments",
}

DATA = {}
AUTHORS = {}
I = 0
J = 0

def parse_authors( records ):

	authors = []

	for i in range(len(records)):
		
		if records[i][0] == "keyname":
			author = { "keyname": records[i][1] }
			i += 1
			try:
				while records[i][0] != "keyname":
					if i == (len(records)-1):
						author[ records[i][0] ] = records[i][1]
						break
					author[ records[i][0] ] = records[i][1]
					i += 1
				authors.append( author )
			except:
				pass

	return authors


def parse_resource__arxiv( record ):

	info = {}
	authors = []
	for i in range(len(record)):
		key = record[i][0]
		value = record[i][1]
		if key in IN:
			if key in Author_Keys:
				authors.append( record[i] )
			else:
				info[ key ] = value

	if "title" in info:
		info["title"] = info["title"].replace("\n" , "").strip()

	if "abstract" in info:
		info["abstract"] = info["abstract"].replace("\n" , " ").strip()

	if "categories" in info:
		info["categories"] = info["categories"].replace(" ","|")


	global DATA
	global AUTHORS
	global I
	global J
	
	# - - - [ ADDING PUBLICATIONS ] - - - #
	standard_info = {}
	for k in sorted( info.keys() ):
		if k in OUT:
			key = OUT[k]
			value = info[k]
			standard_info[ key ] = value
	DATA[ I ] = standard_info
	# - - - [ / ADDING PUBLICATIONS ] - - - #
	

	# - - - [ ADDING AUTHORS ] - - - #
	if len(authors)>1:
		authors = parse_authors( authors )
		if len(authors)>1:
			for author in authors:
				author["p"] = info["id"]
			for author in authors:
				AUTHORS[ J ] = author
				J += 1
	# - - - [ / ADDING AUTHORS ] - - - #

	I += 1


	return True


xmlFile = INPUT
context = etree.iterparse( xmlFile )
c = 0
D = {}
record = []
for action, elem in context:

	tag = elem.tag.replace( "{http://arxiv.org/OAI/arXiv/}","" )

	if tag == "record":
		parse_resource__arxiv( record )
		for i in record:
			key = i[0]
			# print( i[0] ,":", i[1] )
			if key not in D:
				D[ key ] = 0
			D[ key ] += 1
		# print("")
		# print("")
		c += 1
		record = []

	else:
		if elem.text != None:
			record.append( [ tag , elem.text ] )

	# print( [ tag , elem.text ] )
		


print("")
print("")
pprint.pprint( D )
print("")








test_name = INPUT.split("/")[-1].split(".")[0]
sqldbname = test_name+".sqlite"
print(sqldbname)


import sqlite3
conn = sqlite3.connect( sqldbname )
conn.row_factory = sqlite3.Row# Magic line!
conn.isolation_level = None
c = conn.cursor()


sql_commands = [
	"DROP TABLE IF EXISTS publication_author;",
	"CREATE TABLE publication_author( p VARCHAR(250) , keyname VARCHAR(250) , forenames VARCHAR(250), suffix VARCHAR(250) , affiliation TEXT )",
	"DROP TABLE IF EXISTS publication;",
	"CREATE TABLE publication( id VARCHAR(250) , doi VARCHAR(250) , oai_id VARCHAR(250) , name TEXT , date VARCHAR(50) , date_updated VARCHAR(50) , acm_class TEXT, msc_class TEXT , domain VARCHAR(150) , subdomain TEXT , abstract TEXT , comments TEXT , journal TEXT  )",
]

for command in sql_commands:
	c.execute(  command )
	conn.commit()

from SQL import SQL
execc = SQL()
execc.InsertInto_modular( connection=conn , cursor=c , tablename="publication_author" , data= AUTHORS )
execc.InsertInto_modular( connection=conn , cursor=c , tablename="publication" , data= DATA )
conn.close()